#include "alsa.h"
#include "helper_funcs.h"
#include "secret.h"
#include <alsa/asoundlib.h>
#include <arpa/inet.h>
#include <cerrno>
#include <csignal>
#include <cstdint>
#include <cstdio>
#include <cstdlib>
#include <fcntl.h>
#include <iostream>
#include <netdb.h>
#include <netinet/in.h>
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <string>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/wait.h>
#include <unistd.h>

#define PORT 54321

int serverSocket;

int main(int argc, char *argv[]) {

  std::string SecretNumCode_s = "";
  for (char ch : SECRET) {
    uint num = ch - 'a' + 1; // Convert 'a' to 1, 'b' to 2, etc.
    SecretNumCode_s.append(std::to_string(num));
  }
  const long SecretNumCode = std::stoi(SecretNumCode_s);

  // signal handlers
  signal(SIGTERM, safe_exit);
  signal(SIGINT, safe_exit);
  signal(SIGQUIT, safe_exit);
  signal(SIGHUP, safe_exit);

  // error signal handlers
  signal(SIGSEGV, safe_exit);

  // creating socket
  serverSocket = socket(AF_INET, SOCK_STREAM, 0);

  // specifying the address
  sockaddr_in serverAddress;
  serverAddress.sin_family = AF_INET;
  serverAddress.sin_port = htons(PORT);
  serverAddress.sin_addr.s_addr = INADDR_ANY;

  // binding socket.
  while (bind(serverSocket, (struct sockaddr *)&serverAddress,
              sizeof(serverAddress)) != 0) {
    std::cerr << "error binding socket retring\n";
    sleep(2);
  }

  // listening to the assigned socket
  listen(serverSocket, 5);

accept_new_connection:
  // accepting connection request
  int clientSocket = accept(serverSocket, nullptr, nullptr);

  pid_t pid;
  pid = fork();

  if (pid == -1) {
    std::cerr << "Fork failed";
    safe_exit(-1);

  } else if (pid == 0) {
    // child process
    signal(SIGUSR1, exit);
    char bufferSend[1024];
    int volume_percent = INTMAX_MIN;
    int volume_percent_old;
    while (1) {
      volume_percent_old = volume_percent;
      volume_percent = alsa::get_volume("Master");
      if (volume_percent != volume_percent_old) {
      }
      usleep(100000);
      sprintf(bufferSend, "Volume: %d%%\n", alsa::get_volume("Master"));
      if (send(clientSocket, bufferSend, strlen(bufferSend), 0) == -1) {
        std::cerr << "send() returned an error code\n";
        safe_exit(-1);
      }
      sleep(1);
    }

  } else {
    // parent process
    char bufferRecv[1024];
    // recieving data
    while (1) {
      memset(&bufferRecv, 0, sizeof(bufferRecv));
      int RecvRetVal = recv(clientSocket, bufferRecv, sizeof(bufferRecv), 0);
      if (RecvRetVal > sizeof(bufferRecv) || RecvRetVal < 0) {
        std::cerr << "recv() returned an error code\n";
        safe_exit(RecvRetVal);
      } else if (RecvRetVal == 0) {
        // detect if client disconected
        kill(pid, SIGUSR1);
        close(clientSocket);
        goto accept_new_connection;
      }

      std::cout << "Message from client: " << bufferRecv << std::endl;
    }

    // closing the socket.
    close(serverSocket);
  }

  return 0;
}